package lightcontainer.protocol;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public abstract class ProtocolReader {

    private final Pattern rulePattern;

    protected ProtocolReader(String pattern) {
        this.rulePattern = Pattern.compile(pattern);
    }

    /**
     * Permet de lancer la décomposition d'une commande pour en extraire les données
     * @param data Contenu de la commande
     */
    public boolean execute(String data) {
        Matcher ruleMatcher = this.rulePattern.matcher(data);

        if (ruleMatcher.matches()) {
            String[] groups = new String[ruleMatcher.groupCount()];

            for (int i = 1; i <= groups.length; ++i)
                groups[i - 1] = ruleMatcher.group(i);

            onExecuted(groups);
            return true;
        }

        return false;
    }

    /**
     * Cette méthode est appelée lors de l'exécution de la règle
     * @param data
     */
    protected abstract void onExecuted(String... data);

}
